<?php

namespace MoSharePointObjectSync\API;

use MoSharePointObjectSync\Wrappers\pluginConstants;
use MoSharePointObjectSync\Wrappers\wpWrapper;

class SyncMOSPS{

    private static $cron;

    public static function getObserver(): SyncMOSPS
    {
        if(!isset(self::$cron)){
            self::$cron = new SyncMOSPS();
        }
        return self::$cron;
    }

    public function mo_sps_sync_doc_schedule($schedule){

        $mo_sps_interval = wpWrapper::mo_sps_get_option(pluginConstants::SYNC_INTERVAL);
        if(empty($mo_sps_interval))
            $mo_sps_interval = 30;

        $schedule['mo_sps_sync_doc'] = [
            'interval' => 60*$mo_sps_interval,
            'display' => __('SharePoint Sync')
        ];

        return $schedule;
    }

    public function mo_sps_sync_doc_action(){
        error_log("####################################################");
        error_log("            ###########################             ");
        error_log("                    ############                    ");
        error_log("####### syncing started.... at ".date('m/d/Y H:i:s', time())." ############");

        $data = wpWrapper::mo_sps_get_option(pluginConstants::APP_CONFIG);
        if(!$data || empty($data)){
            return;
        }
        $azure_client = Azure::getClient($data);
        $azure_client->mo_sps_sync_all_documents_from_sharepoint();
    }

}