<?php

namespace MoSharePointObjectSync\View;

use MoSharePointObjectSync\Wrappers\pluginConstants;
use MoSharePointObjectSync\Wrappers\wpWrapper;

class accountSetup {

    private static $accountSetup;

    public static function getView(){
        if(!isset(self::$accountSetup)){
            self::$accountSetup = new accountSetup;
        }
        return self::$accountSetup;
    }

    public function mo_sps_display__tab_details(){
        
        ?>
        <div class="mo-ms-tab-content">
            <h2>Account Setup</h2>
            <div style="width: 70%">
                <div class="mo-ms-tab-content-left-border">
                    <?php
                    if(wpWrapper::mo_sps_is_customer_registered() && wpWrapper::mo_sps_is_customer_license_key_verified()){
                        $this->mo_sps_display__account_information();
                    }else if(!wpWrapper::mo_sps_is_customer_registered()){
                        $this->mo_sps_display__show_login_page();
                    }else if(wpWrapper::mo_sps_is_customer_registered() && !wpWrapper::mo_sps_is_customer_license_key_verified()){
                        $this->mo_sps_display__verify_license_page();
                    }
                    ?>
                </div>
            </div>
        </div>
        <?php
    }

    private function mo_sps_display__account_information(){
        ?>
        <form class="mo_msgraph_ajax_submit_form" id="mo_sps_remove_account_form" method="post">
            <input type="hidden" name="option" value="mo_sps_remove_account_option">
            <input type="hidden" name="mo_sps_tab" value="account_setup">
            <?php wp_nonce_field('mo_sps_remove_account_option');?>
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 400;">Your Profile</span>
                    </br></br>
                    <span>Thanks for upgrading to <b>Premium</b> plugin.</span>
                    </br>
                    </br>
                    <div >
                    <table border="1" style="background-color:#FFFFFF; border:1px solid #CCCCCC; border-collapse: collapse; padding:0px 0px 0px 10px; margin:2px; width:85%">
                        <tr>
                            <td style="width:45%; padding: 10px;">miniOrange Account Email</td>
                            <td style="width:55%; padding: 10px;"><?php echo get_option('mo_saml_admin_email'); ?></td>
                        </tr>
                        <tr>
                            <td style="width:45%; padding: 10px;">Customer ID</td>
                            <td style="width:55%; padding: 10px;"><?php echo get_option('mo_saml_admin_customer_key'); ?></td>
                        </tr>
                    </table>
                    </br>
                    <input type="submit" class="button button-primary button-large" value="Remove Account">
                    </div>
                </div>
            </div>
        </form>
        <?php
    }

    private function mo_sps_display__show_login_page(){

        $account_email = get_option('mo_saml_admin_email');

        ?>
        <form class="mo_msgraph_ajax_submit_form" id="mo_sps_account_form" method="post">
            <input type="hidden" name="option" value="mo_sps_account_setup_option">
            <input type="hidden" name="mo_sps_tab" value="account_setup">
            <?php wp_nonce_field('mo_sps_account_setup_option');?>
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 400;">Login with miniOrange</span>
                    </br></br>
                    <b><a href="https://login.xecurify.com/moas/idp/resetpassword" target="_blank">Click here if you forgot your password?</a></b></p>
                    <div >
                        <table class="mo-ms-tab-content-app-config-table">
                            <colgroup>
                                <col span="1" style="width: 10%;">
                                <col span="2" style="width: 50%;">
                            </colgroup>
                            <tr>
                                <td><span>Email<sup style="color:red">*</sup></span></td>
                                <td>
                                    <input type="email" required placeholder="person@example.com" name="account_email" value='<?php echo $account_email;?>'>
                                </td>
                            </tr>
                            <tr>
                                <td><span>Password<sup style="color:red">*</sup></span></td>
                                <td><input type="password" required placeholder="Enter your password" name="account_pwd"
                                    minlength="6" pattern="^[(\w)*(!@#.$%^&*-_)*]+$"
                                    title="Minimum 6 characters should be present. Maximum 15 characters should be present. Only following symbols (!@#.$%^&*-_) should be present"
                                    >
                                </td>
                            </tr>
                            <tr><td></br></td></tr>
                            <tr>
                                <td>
                                    <input type="submit" class="button button-primary button-large" value="Login">
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </form>
        <?php
    }

    private function mo_sps_display__verify_license_page(){
        if(wpWrapper::mo_sps_site_check()){
        ?>
        <form class="mo_msgraph_ajax_submit_form" id="mo_sps_verify_license_form" method="post">
            <input type="hidden" name="option" value="mo_sps_verify_license_option">
            <input type="hidden" name="mo_sps_tab" value="account_setup">
            <?php wp_nonce_field('mo_sps_verify_license_option');?>
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 400;">Verify License [ <span style="font-size:13px;font-style:normal;"><a style="cursor:pointer;" target="_blank" href=<?php echo pluginConstants::HOSTNAME.'/moas/viewlicensekeys' ?> >Click here to view your license key</a></span> ]</span>
                    <div >
                        <table class="mo-ms-tab-content-app-config-table">
                            <colgroup>
                                <col span="1" style="width: 40%;">
                                <col span="2" style="width: 50%;">
                            </colgroup>
                            <tr>
                                <td><span>Enter your license key to activate the plugin<sup style="color:red">*</sup></span></td>
                                <td>
                                <input required type="text"
                                name="mo_sps_licence_key" placeholder="Enter your license key to activate the plugin"/>
                                </td>
                            </tr>
                            <tr><td></br></td></tr>
                            <tr>
                                <td><span>Please check this to confirm that you have read it<sup style="color:red">*</sup></span></td>
                                <td>
                                    <input required type="checkbox" name="mo_sps_license_conditions"/>
                                </td>
                            </tr>
                            <tr><td></br></td></tr>
                            <tr>
                                <td colspan="2">1. License key you have entered here is associated with this site instance. In future, if you are re-installing the plugin or your site for any reason. You should deactivate and then delete the plugin from wordpress console and should not manually delete the plugin folder. So that you can resuse the same license key.</td>
                            </tr>
                            <tr>
                                <td colspan="2">2. <b>This is not a developer's license.</b> Making any kind of change to the plugin's code will delete all your configuration and make the plugin unusable.</td>
                            </tr>
                            <tr><td></br></td></tr>
                            <tr>
                                <td colspan="2">
                                    <div style="display:flex;justify-content:flex-start;align-items:center;">
                                        <input style="margin:5px" type="submit" class="button button-primary button-large" value="Activate">
                                        <input style="margin:5px" type="button" class="button button-primary button-large" value="Back" id="mo_sps_go_back_from_license_page"/>
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </form>
        <form id="mo_sps_go_back_from_license_page_form" method="post" name="mo_sps_go_back_from_license_page_form">
            <input type="hidden" name="option" value="mo_sps_go_back_from_license_page_option">
            <input type="hidden" name="mo_sps_tab" value="account_setup">
            <?php wp_nonce_field('mo_sps_go_back_from_license_page_option');?>
        </form>
        <script>
            document.getElementById("mo_sps_go_back_from_license_page").addEventListener("click",function (event){
                document.getElementById("mo_sps_go_back_from_license_page_form").submit();
            });
        </script>
        <?php
        }

    }

}