<?php


namespace MoSharePointObjectSync\View;

use MoSharePointObjectSync\Wrappers\sharepointWrapper;
use MoSharePointObjectSync\Wrappers\wpWrapper;
use MoSharePointObjectSync\Wrappers\pluginConstants;
class adminView{
    private static $instance;

    public static function getView(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_sps_menu_display(){
        if( isset( $_GET[ 'tab' ] ) ) {
            $active_tab = sanitize_text_field($_GET['tab']);
        }else{
            $active_tab = 'app_config';
        }
        $this->mo_sps_display_tabs($active_tab);
    }
    private function mo_sps_display_tabs($active_tab){
            echo '<div style="display:flex;justify-content:space-between;align-items:flex-start;padding-top:8px;"><div style="width:100% !important;" id="mo_sps_container" class="mo-container">';
            $this->mo_sps_display__header_menu();
            $this->mo_sps_display__tabs($active_tab);
        
            echo '<div style="display:flex;justify-content:space-between;align-items:flex-start;">';
            $this->mo_sps_display__tab_content($active_tab);
            $supportFormHandler = supportForm::getView();
            $supportFormHandler->mo_sps_display_support_form();
        echo '</div></div>';
            echo '</div>';
            
            
    }

    private function mo_sps_display__header_menu(){
       ?>
        <div style="display: flex;">
            <img id="mo-ms-title-logo" src="<?php echo esc_url(plugin_dir_url(MO_SPS_PLUGIN_FILE).'images/miniorange.png');?>">
            <h1><label for="sync_integrator">Embed SharePoint OneDrive Documents</label></h1>
        </div>
        <?php
    }

    private function mo_sps_display__tabs($active_tab){
        $state = wpWrapper::mo_sps_get_option(pluginConstants::CURRENT_STATE);
        $value = !empty($state)?$state:"/Shared Documents/";
        ?>
        <div class="mo-ms-tab ms-tab-background mo-ms-tab-border">
            <ul class="mo-ms-tab-ul">
                <li id="app_config" class="mo-ms-tab-li">
                    <a href="<?php echo esc_url_raw(admin_url('admin.php?page=mo_sps&tab=app_config'));?>">
                        <div id="application_div_id" class="mo-ms-tab-li-div <?php
                        if($active_tab == 'app_config'){
                            echo 'mo-ms-tab-li-div-active';
                        }
                        ?>" aria-label="Application" title="Application Configuration" role="button" tabindex="0">
                            <div id="add_icon" class="mo-ms-tab-li-icon" >
                                <img style="width:20px;height:20px" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/microsoft-sharepoint.svg');?>">
                            </div>
                            <div id="add_app_label" class="mo-ms-tab-li-label">
                                Manage Application
                            </div>
                        </div>
                    </a>
                </li>

                <li id="Documents" class="mo-ms-tab-li" style="margin-left:10px;" role="presentation" title="user_manage">
                    <a href="<?php echo (add_query_arg(['tab'=>'Documents','fetch'=>1,'serverRelativeURL'=>$value]));?>">
                    <?php
                    ?>
                    <input type="hidden" id="Documents_tab" value="<?php echo esc_url_raw(add_query_arg(['tab'=>'Documents','fetch'=>1,'serverRelativeURL'=>$value]));?>">
                        <div id="Documents_id" class="mo-ms-tab-li-div <?php
                        if($active_tab == 'Documents'){
                        echo 'mo-ms-tab-li-div-active';
                        }
                        ?>" aria-label="Documents" title="Documents" role="button" tabindex="0">
                            <div id="add_icon" class="mo-ms-tab-li-icon" >
                                <img class="filter-green" style="width:20px;height:20px;"
                                 src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/folder_main.svg');?>">
                            </div>
                            <div id="add_app_label" class="mo-ms-tab-li-label">
                                Documents / Files
                            </div>
                        </div>
                    </a>
                </li>

                <li id="sync_user" class="mo-ms-tab-li" style="margin-left:10px;" role="presentation" title="user_manage">
                    <a href="<?php echo esc_url_raw(admin_url('admin.php?page=mo_sps&tab=sync_user'));?>">
                    <input type="hidden" id="sync_user_tab" value="<?php echo esc_url_raw(add_query_arg('tab','sync_user'));?>">
                    <div id="sync_user_id" class="mo-ms-tab-li-div <?php
                        if($active_tab == 'sync_user'){
                            echo 'mo-ms-tab-li-div-active';
                        }
                        ?>" aria-label="sync_user" title="Sync User" role="button" tabindex="0">
                            <div id="add_icon" class="mo-ms-tab-li-icon" >
                                <img class="filter-green" style="width:20px;height:20px;
                            " src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/users.svg');?>">
                            </div>
                            <div id="add_app_label" class="mo-ms-tab-li-label">
                                SharePoint User Profile
                            </div>
                        </div>
                    </a>
                </li>

                <li id="pb_app_config" class="mo-ms-tab-li" style="margin-left:10px;">
                    <a href="<?php echo esc_url_raw(add_query_arg('tab','setup_guide'));?>">
                        <div id="application_div_id" class="mo-ms-tab-li-div <?php
                        if($active_tab == 'setup_guide'){
                            echo 'mo-ms-tab-li-div-active';
                        }
                        ?>" aria-label="Setup Guide" title="Setup Guide" role="button" tabindex="0">
                            <div id="add_icon" class="mo-ms-tab-li-icon" >
                                <img  src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/add.svg');?>">
                            </div>
                            <div id="setup_guide" class="mo-ms-tab-li-label">
                               Setup Guide
                            </div>
                        </div>
                    </a>
                </li>

            </ul>
        </div>
        
        <?php
    }
    private function mo_sps_display__tab_content($active_tab){
        $handler = self::getView();
        switch ($active_tab){
            case 'app_config':{
                $handler = appConfig::getView();
                break;
            }
            case 'sync_user':{
                $handler = syncUser::getView();
                break;
            }
            case 'Documents':{
                $handler = documentsSync::getView();
                break;
            }
            case 'setup_guide':{
                $handler = setupGuide::getView();
                break;
            }
            
        }
        
        $handler->mo_sps_display__tab_details();
        
    }

    private function mo_sps_display__tab_details(){
       esc_html_e("Class missing. Please check if you've installed the plugin correctly.");
    }
    
}