<?php

namespace MoSharePointObjectSync\View;

use MoSharePointObjectSync\Wrappers\pluginConstants;
use MoSharePointObjectSync\Wrappers\wpWrapper;

class appConfig{

    private static $instance;

    public static function getView(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_sps_display__tab_details(){
        ?>
        <div class="mo-ms-tab-content" style="width:77rem;">
            <h1>Configure Microsoft SharePoint Online Application</h1>
            <div style="width: 68%">
                <div class="mo-ms-tab-content-left-border">
                    <?php
                    $this->mo_sps_display__client_config();
                    
                    ?>
                </div>
            </div>
        </div>
        <?php
    }

    private function mo_sps_display__client_config(){
        $app = wpWrapper::mo_sps_get_option(pluginConstants::APP_CONFIG);
        $client_id = !empty($app['client_id'])?$app['client_id']:'';
        $admin_uri = !empty($app['admin_uri'])?$app['admin_uri']:'';
        $tenant_id = !empty($app['tenant_id'])?$app['tenant_id']:'';
        $upn_id = !empty($app['upn_id'])?$app['upn_id']:'';
        if(isset($app['client_secret']) && !empty($app['client_secret'])){
            $client_secret = wpWrapper::mo_sps_decrypt_data($app['client_secret'],hash("sha256",$client_id));
        }else{
            $client_secret = '';
        }
        ?>
        <form class="mo_sps_ajax_submit_form" action="" method="post">
            <input type="hidden" name="option" id="app_config" value="mo_sps_client_config_option">
            <input type="hidden" name="mo_sps_tab" value="app_config">
            <?php wp_nonce_field('mo_sps_client_config_option');?>
            <div class="mo-ms-tab-content-tile" style="width:135%;">
                <div class="mo-ms-tab-content-tile-content">
                    <div style="display: inline">
                        <span style="font-size: 18px;font-weight: 200;display: inline-block">1. Basic App Configuration &nbsp;&nbsp;</span>
                        <span><a target="_blank" href="<?php echo add_query_arg(["page"=>"mo_sps","tab"=>"setup_guide"],get_admin_url().'admin.php');?>" class="button button-primary" style="display: inline-block; background: black">Click here to open Setup Guide</a> </span>
                    </div>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td class="left-div"><span>Application ID <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="Enter Your Application (Client) ID" style="width:75%;" type="text" name="client_id" value="<?php echo esc_html($client_id);?>"></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td>
                                <b>Note:</b> You can find the <b>Application ID</b> in your Active Directory application's Overview tab. 
                            </td>
                        </tr>
                        <tr>
                            <td></br></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Client Secrets <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input autoComplete="new-password" placeholder="Enter Your Client Secret" style="width:75%;" type="password" name="client_secret" value="<?php echo esc_html($client_secret);?>"></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td>
                                <b>Note:</b> You can find the <b>Client Secret</b> value in your Active Directory application's Certificates & Secrets tab. 
                            </td>
                        </tr>
                        <tr>
                            <td></br></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>SharePoint Online URL<span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="https://<tenant-name>.sharepoint.com" style="width:75%;" type="url" name="admin_uri" value="<?php echo esc_html($admin_uri);?>"></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td>
                                <b>Note:</b> Enter your SharePoint online URL.
                            </td>
                        </tr>
                        <tr>
                            <td></br></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Tenant ID <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="Enter Your Directory (Tenant) ID" style="width:75%;" type="text" name="tenant_id" value="<?php echo esc_html($tenant_id);?>"></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td>
                                <b>Note:</b> You can find the <b>Tenant ID</b> in your Active Directory application's Overview tab. 
                            </td>
                        </tr>
                        <tr>
                            <td></br></td>
                        </tr>
                        
                        <tr>
                            <td></td>
                            <td>
                                <div style="display: flex;justify-content:flex-start;align-items:center;">
                                    <div style="display: flex;margin:1px;">
                                        <input style="height:30px;" type="submit" id="saveButton" class="mo-ms-tab-content-button" value="Save">
                                    </div>
                                    <div style="margin:10px;">
                                        <input style="height:30px;" id="view_attributes" type="button" class="mo-ms-tab-content-button" value="Test Configuration" onclick="showAttributeWindow()">
                                    </div>
                                </div>
                            </td>
                        </tr>

                    </table>
                </div>
            </div>
        </form>
        <script>
            function showAttributeWindow(){
                document.getElementById("app_config").value = "mo_sps_app_test_config_option";
                var myWindow = window.open("<?php echo esc_url_raw($this->mo_sps_get_test_url()); ?>", "TEST User Attributes", "scrollbars=1, width=800, height=600");
            }
        </script>
        <?php
    }

    
    

    private function mo_sps_get_test_url(){
        return admin_url('?option=testSPSApp');
    }
}