<?php

namespace MoSharePointObjectSync\View;

use MoSharePointObjectSync\Wrappers\pluginConstants;
use MoSharePointObjectSync\Wrappers\wpWrapper;
use MoSharePointObjectSync\Observer\documentObserver;

use DateTime;

class documentsSync{

    private static $instance;

    public static function getView(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }
 

    public function mo_sps_display__tab_details(){

        $document_sync_metdata = [
            'admin_url' => admin_url(),
            'serverRelativeURL' => isset($_REQUEST['serverRelativeURL'])?$_REQUEST['serverRelativeURL']:'',
            'folder_icon_url' => esc_url(plugin_dir_url(__FILE__).'../images/folder.svg'),
            'files_icon_url'=> esc_url(plugin_dir_url(__FILE__).'../images/document.png'),
            'fetch'=> isset($_REQUEST['fetch'])?$_REQUEST['fetch']:'1'
        ];

        ?>
        <div class="mo-ms-tab-content" style="width:77rem;">
        <div style="display:flex;">
            <div><h1>Sync Documents</h1></div>
        </div>
            

            
            <div style="width: 68%">
                <div class="mo-ms-tab-content-left-border">
                    <?php
                  $this->mo_sps_display_sync_documents();
                $sync_js_url= plugins_url('../includes/js/ajax.js',__FILE__);
                wp_enqueue_script('mo_sps_sync_js',$sync_js_url,array());
                wp_localize_script('mo_sps_sync_js','doc_sync_data',$document_sync_metdata);
                
                    ?>
                    
                </div>
            </div>
        </div>
        <?php
    }
    private function mo_sps_display_sync_documents(){
        ?>
        <form id="wp_save_user_form" method="post" name="wp_save_user_form">
            <div class="mo-ms-tab-content-tile" style="width:135%;">
                <div class="mo-ms-tab-content-tile-content">
            <div style="display:flex;align-items: center;justify-content: space-between;">
            <div style="font-weight: 350;width: 99%;">
                    <?php
                    $breadcrump = substr($_REQUEST['serverRelativeURL'], 1);
                    $breadcrump_array = explode("/",$breadcrump);
                    $breadcrump_array = array_map('trim', $breadcrump_array);
                    $breadcrump_array = array_filter($breadcrump_array);
                    $noofelement = sizeof($breadcrump_array);
                    $strt = 0;
                    $temp ="";
                    foreach($breadcrump_array as $element){
                        if($element!="" && $strt && $strt<$noofelement)
                        {
                            ?>
                            <span style="font-size: 18px;font-weight: 200;">
                            <?php
                            echo esc_html(">");  
                            ?>
                            </span>
                            <?php
                        }
                        
                        $temp = $temp."/".$element."/";
                        if($strt<$noofelement-1){
                            ?>
                            <span style="font-size: 18px;font-weight: 200;">
                            <a id="bread" style="text-decoration:none;" href="<?php echo esc_url_raw(add_query_arg(['tab'=>'Documents','fetch'=>1,'serverRelativeURL'=>$temp]));?>"><?php echo esc_html($element);?></a> 
                        </span>
                        <?php
                        }
                    ?>
                    <?php 
                    if($strt==$noofelement-1){
                        ?>
                        <span style="font-size: 18px;font-weight:500;">
                        <a id="bread" style="text-decoration:none;" href="<?php echo esc_url_raw(add_query_arg(['tab'=>'Documents','fetch'=>1,'serverRelativeURL'=>$temp]));?>"><?php echo esc_html($element);?></a> 
                    </span>
                        <?php
                    }       
                        $strt++;
                        ?>
                    <?php
                        
                    }
             
                    ?>
 
                
                </div>
                <div ><a id="refresh" href=""><img style="width:20px;height:20px;margin-top:14px;margin-left:8px;" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/refresh.svg');?>"></a></div>
            </div>

                


        <div style="padding-bottom:20px;"></div>


        <table id="reports_table" class="wp-list-table widefat fixed table-hover table-view-list pages" style="width:99%;border:none;display:none;">
        <thead></thead>
        <thead></thead>
	    <thead>
		        <tr>
		            <td style = "width:39%;">Name</td>
			        <td style = "width:20%;">Last Modified</td>
                    <td style = "width:20%;text-align:center;">Size</td>
                    <td style = "width:20%;text-align:center;">Item Count</td>
		        </tr>    
        </thead>
        <tbody id="mo_sps_report_tbody">
                    
            </tbody>
        </table>
                    
                    
                
        <table id="empty_table" class="wp-list-table more widefat fixed table-hover table-view-list pages" style="width:99%;border:none;display:none;">
        <thead></thead>
        <thead></thead>
        <thead>
            <tr>
                <td style = "width:39%;">Name</td>
                <td style = "width:20%;">Last Modified</td>
                <td style = "width:20%;">Size</td>
                <td style = "width:20%;">Item Count</td>
            </tr>    
        </thead>
        <tbody>
            <tr>
            <td></td>
            <td colspan="1">
            <img style="width:300px;height:300px;display:flex;align-items:center;display: block;margin-left: auto;margin-right: auto;" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/empty_folder_drop.svg');?>">
                <div style="display:flex;justify-content:center;">This folder is empty</div>
            </td>
            </tr>
        </tbody>
        </table>


        <div id="error_table" hidden >
        <table class="wp-list-table widefat more fixed table-hover table-view-list pages" style="width:99%;border:none;">
            <thead></thead>
            <thead></thead>
            <thead>
                <tr>
                    <td style = "width:39%;">Name</td>
                    <td style = "width:20%;">Last Modified</td>
                    <td style = "width:20%;">Size</td>
                    <td style = "width:20%;">Item Count</td>
                </tr>    
            </thead>
            <tbody>
            <tr>
                <td></td>
                <td colspan="1">
            <img style="margin-top:30px;width:35px;height:35px;display:flex;align-items:center;display: block;margin-left: auto;margin-right: auto;" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/error.svg');?>">
                </td>
                </tr>
                <tr>
                <td colspan="4">
                    <div style="margin-left:60px;font-weight:500;">SharePoint Application is not configured Correctly yet, Please&nbsp;<a href="<?php echo esc_url_raw(admin_url('admin.php?page=mo_sps&tab=app_config'));?>">CLICK HERE</a> &nbsp;To Configure the test Correctly.</div>
                    </td>
                </tr>
            </tbody>
            </table>
        </div>






        <table id="loader" class="wp-list-table widefat more fixed table-hover table-view-list pages" style="width:99%;border:none;">
            <thead></thead>
            <thead></thead>
            <thead>
                <tr>
                    <td style = "width:39%;">Name</td>
                    <td style = "width:20%;">Last Modified</td>
                    <td style = "width:20%;">Size</td>
                    <td style = "width:20%;">Item Count</td>
                </tr>    
            </thead>
            <tbody>

            
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr>
                <td></td>
                <td colspan="1">
            <img style="margin-top:30px;width:35px;height:35px;display:flex;align-items:center;display: block;margin-left: auto;margin-right:auto;" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/Chasing_arrows.gif');?>">
                </td>
            </tr>
            <tr>
            <td></td>
                <td colspan="12">
                    <div style="display:flex;align-items:center;display: block;margin-left: 50px;margin-right:auto;font-weight:500;">Loading...</div>
                    </td>
            </tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
            <tr><td></td><td></td><td></td><td></td></tr>
      

                
            </tbody>
            </table>






            </div>
        </div>   
    </form>
    
    
    <?php
    }

 



  

}