<?php

namespace MoSharePointObjectSync\View;

use MoSharePointObjectSync\Wrappers\pluginConstants;
use MoSharePointObjectSync\Wrappers\wpWrapper;


class setupGuide
{

    private static $instance;

    public static function getView()
    {
        if (!isset(self::$instance)) {
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_sps_display__tab_details()
    {
         ?>
    <table style="width:97%;">
     <tbody>
      <td style="vertical-align:top;width:77rem;">
      <div class="mo-epbr-setup-tab-content">
		<h1>
            How to configure the plugin
        </h1>
        <div class="mo-epbr-setup-tab-content-tile">
            <div class="mo-epbr-setup-tab-content-tile-content mo-epbr-guide-text">
              <h3>1. Configure the Azure AD App registration:</h3>
              <ul class="mo-epbr-guide-ul">
                 <li>
                    Log in to Azure AD Portal, <a href="https://portal.azure.com/ " target="_blank"><b><u>Azure AD application</u></b></a> as an Administrator.
                 </li>
                 <li>
                 You will be represented with the home screen of Azure Active Directory. 
                 </li>
                 <li style="margin-bottom:20px;">
                 Under the Azure Services section, select Azure Active Directory.
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/first.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div></div>
                <li style="margin-top:20px;">
                In the left tab, under the Manage section, select App registrations tab.
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/second_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>
                Click on the <b>New Registration</b> option. 
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/third_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>
                Assign the <b>Display Name</b> in the name field and choose the account type.
                </li>
                <li>
                In the <b>Redirect URI </b>field, provide the URL of your <b>WordPress site</b> and click on <b>Register </b>button.
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/4_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>
                After the registration of an application, Azure AD assigns an unique application ID to your application.
                </li>
                <li>
                Navigate to the Overview tab, in the left pane.
                </li>
                <li>
                Copy the Application ID and the Directory ID, this will be your Client ID and Tenant ID.
                </li>  
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/fifth_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                
                <li>
                From the left navigation pane, navigate to the Certificates & secrets tab.
                </li>
                <li>
                Click on New client secret. Enter the description and expiration time and click on the ADD option. 
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/seventh_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>
                Copy the value of Secret Key. This will be your Client Secret Key.
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/eight_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>
                <h2>Granting permissions to the newly created principal: </h2>
                </li>
                <li>
                Log in to SharePoint online admin centre https://<tenant-name>-admin.sharepoint.com (e.g. https://contoso-admin.sharepoint.com/) 
                </li>
                <li>
                Go to https://<tenant-name>-admin.sharepoint.com/_layouts/15/appinv.aspx 
                </li>
                <li>
                Once the page is loaded, add your client ID and look up the created principal 
                </li>
                <li>
                To grant permissions, you'll need to provide the permission XML that describes the needed permissions. Since this application needs to be able to access all sites + user information, it needs below permissions 
                </li>
                <li>
                <xmp>
<AppPermissionRequests AllowAppOnlyPolicy="true"> 
<AppPermissionRequest Scope="http://sharepoint/content/tenant" Right="FullControl" /> 
<AppPermissionRequest Scope="http://sharepoint/social/tenant" Right="FullControl" />
</AppPermissionRequests>
                </xmp>
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/ninth_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>
                When you click onCreate, you'll be presented with a permission consent dialogue. Press Trust It to grant the permissions:
                </li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/tenth_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div style="margin-bottom:20px;"></div>
                <li>
                <div><h2>Note: If you are not able to access https://<tenant-name>-admin.sharepoint.com/_layouts/15/appinv.aspx </h2></div>
                </li>
                <li style="margin-bottom:10px;font-weight:500"> Open Windows PowerShell as an administrator. And run below commands:</li>
                <li>Install-Module -Name Microsoft.Online.SharePoint.PowerShell</li>
                <li>$adminUPN=<xmp>"<the full email address of a SharePoint administrator account, 
example: jdoe@contosotoycompany.onmicrosoft.com>"</xmp></li>
                <li><xmp>$orgName="<name of your Office 365 organization, example: contosotoycompany>"</xmp></li>
                <li>$userCredential = Get-Credential -UserName $adminUPN -Message "pwd"</li>
                <li>Connect-SPOService -Url https://$orgName-admin.sharepoint.com -Credential $userCredential</li>
                <li>set-spotenant -DisableCustomAppAuthentication $false</li>

                <div><h4>Note: Fill in the values for the $adminUPN and $orgName variables (replacing all the text between the quotes, including the < and > characters), and then run the following commands in the Windows PowerShell. When prompted with the Windows PowerShell credential request dialog box, type the password for the SharePoint admin account.</h3></div>
                <li>
                <h2> Plugin Configurations: </h2>
                </li>
                <li>
                Navigate to the SharePoint Online Premium plugin. 
                </li>
                <li style="margin-bottom:20px;">
                Under the Manage Application tab, paste the information from the Azure AD App.
                </li>

                <table style="width:100%;border:1px solid black;">
                    <tr style="width:50%;border:1px solid black;">
                        <td>Application ID</td>
                        <td>==></td>
                        <td>Paste the Application ID from Azure AD App.</td>
                    </tr>
                    <tr style="width:50%;border:1px solid black;">
                        <td>Client Secret </td>
                        <td>==></td>
                        <td>Paste the Client Secret from the Azure AD App.</td>
                    </tr>
                    <tr style="width:50%;border:1px solid black;">
                        <td>Tenant ID </td>
                        <td>==></td>
                        <td>Paste the Directory ID from Azure AD App.</td>
                    </tr>
                    <tr style="width:50%;border:1px solid black;">
                        <td>SharePoint URL </td>
                        <td>==></td>
                        <td>https://<-tenant-name->.sharepoint.com</td>
                    </tr>
                </table>
                <div style="margin-bottom:20px;"></div>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/eleven_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div style="margin-bottom:20px;"></div>
                <li>Click on Save button.</li>
                <li>Click on the Test Configuration button.</li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/twelveth_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div style="margin-bottom:20px;"></div>
                <li><h2>Documents / Files</h2></li>
                <li>Navigate to Documents / Files Tab to sync all your sharepoint files and folders</li>
                <div style="margin-bottom:20px;"></div>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/13_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div style="margin-bottom:20px;"></div>
                <li><h2>Sync Sharepoint User Profile</h2></li>
                <li>Navigate to SharePoint User Profile to sync your user to wordpress from sharepoint online</li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/14_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <li>To sync your particular user you need to enter UPN.</li>
                <li>Click on Save button.</li>
                <li>Click on Fetch Attribute button to view user information.</li>
                <li>Click on Sync User button.</li>
                <li>user table before sync</li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/16_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div style="margin-bottom:20px;"></div>
                <li>user table After sync</li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/17_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
                <div style="margin-bottom:20px;"></div>
                <li>Scroll down to user profile mapping section if you want to map the profile attribute</li>
                <img width="95%" src="<?php echo esc_url(plugin_dir_url(__FILE__).'../images/15_step.png');?>" loading="lazy" class="mo-epbr-guide-image" alt="Azure AD user sync with WordPress - Admin consent">
              </ul>
        </div>
      </div>
      </td>
     </tbody>
   </table>
<?php
    }
}
