jQuery(document).ready( function($){

    function mo_sps_formatBytes(size,precision = 2)
    {
    base = Math.log(size)/Math.log(1024);
    suffixes = ['', 'KB', 'MB', 'GB', 'TB'];   
    return Math.round(Math.pow(1024, base - Math.floor(base)), precision) +' '+ suffixes[Math.floor(base)];
    }
    
function dateFormat(inputDate, format) {
  
  const date = new Date(inputDate);
  const day = date.getDate();
  const month = date.getMonth() + 1;
  const year = date.getFullYear();   
  format = format.replace("MM", month.toString().padStart(2,"0"));        
  if (format.indexOf("yyyy") > -1) {
      format = format.replace("yyyy", year.toString());
  } else if (format.indexOf("yy") > -1) {
      format = format.replace("yy", year.toString().substr(2,2));
  }
  format = format.replace("dd", day.toString().padStart(2,"0"));

  return format;
}


    $.ajax({
      url: doc_sync_data.admin_url+"admin-ajax.php", // this is the object instantiated in wp_localize_script function
      type: 'GET',
      data:{
        action: 'mysyncaction', // this is the function in your functions.php that will be triggered
        'serverRelativeURL':doc_sync_data.serverRelativeURL,
        'fetch':doc_sync_data.fetch

      },
      beforeSend: function() {    
        document.getElementById("loader").removeAttribute("hidden");
        },
      success: function( data ){

        document.getElementById("loader").setAttribute("hidden","");
        localStorage.removeItem('fetch_again');
        
        let Documents = JSON.parse(data.data);
        if(Documents!=""){

        let Folders_array = Documents.Folders.results;
        let Files_array = Documents.Files.results;
        let noOfFolders = Documents.Folders.results.length;
        let noOfFiles = Documents.Files.results.length;
        
        let params = new URLSearchParams(window.location.search)
        let breadcrump = params.get('serverRelativeURL');
        
        breadcrump = breadcrump.substring(1);

        let breadcrump_array = breadcrump.split("/");
        
        breadcrump_array = breadcrump_array.filter(entry => entry.trim()!= '');
        let noofelement = breadcrump_array.length;

        let strt = 0;
        let temp = "";
        
        let parent = document.getElementById("breadcrump");

        // following code is adding breadcrumbs

        for(i in breadcrump_array){

            temp+="/"+breadcrump_array[i]+"/";
            
            let refresh = document.getElementById("refresh");
            refresh.href = doc_sync_data.admin_url+"/admin.php?page=mo_sps&tab=Documents&fetch=0&serverRelativeURL="+temp;

        }
        

        // code from here is for table items showing files and folders

        let total_row = noOfFiles + noOfFolders;
        if(noOfFiles || noOfFolders){
            let table_1 = document.getElementById("reports_table");
            table_1.style.display = "";
            
            var table = document.getElementById("mo_sps_report_tbody");


            for (let i = 0; i<noOfFolders; i++) {
                    if(Folders_array[i].Name!='Forms'){
                        var row = table.insertRow(); 
                var cell1 = row.insertCell();
                var cell2 = row.insertCell();
                var cell3 = row.insertCell();
                var cell4 = row.insertCell();

                
                cell1.style.display = "flex";
                cell1.style.align = "center";

                cell1.innerHTML =  '<img style="width:20px;height:20px;margin-right:10px;" src="'+doc_sync_data.folder_icon_url+'" >'+'<a id="mo_a_hover" href="'+doc_sync_data.admin_url+"/admin.php?page=mo_sps&tab=Documents&fetch=1&serverRelativeURL="+Folders_array[i].ServerRelativeUrl+'">'+Folders_array[i].Name+'</a>';
                cell2.innerHTML =   dateFormat(Folders_array[i].TimeLastModified, 'dd-MM-yyyy');
                cell3.innerHTML = "";
                cell4.innerHTML = Folders_array[i].ItemCount;
                cell4.style.textAlign = "center";
    
                    }
            }
            for (let j = 0; j<noOfFiles; j++){
                var row = table.insertRow(); 
                var cell1 = row.insertCell();
                var cell2 = row.insertCell();
                var cell3 = row.insertCell();
                var cell4 = row.insertCell();
                cell1.style.display = "flex";
                cell1.style.align = "center";
                cell1.innerHTML = '<img style="width:20px;height:20px;margin-right:10px;" src="'+doc_sync_data.files_icon_url+'" >'+Files_array[j].Name;
                cell2.innerHTML = dateFormat(Files_array[j].TimeLastModified, 'dd-MM-yyyy');
                cell3.innerHTML = mo_sps_formatBytes(Files_array[j].Length,0);
                cell3.style.textAlign = "center";
                cell4.innerHTML = "";                   
            }      
        }
        // following code is to check if there is no file to show
        else{
            let table_2 = document.getElementById("empty_table");
            table_2.style.display = "block";
        }
    }
    // following code works if access token is not generated correctly
    else{
        let table_3 = document.getElementById("error_table");
        table_3.style.display = "block";
    }
      }
    }); 
  });